#include <iostream>
#include <string>

#include <IceUtil/IceUtil.h>

using namespace std;
using namespace IceUtil;

class DummyThread : public Thread {
public :
    DummyThread() {
        ThreadControl tc = start();
        tc.detach();
    }

    void run() {
        // The DummyThread finishes quickly, so a crash is
        // caused inside the 'start()' method
    }
};

// ThreadRunner creates DummyThreads periodically.
class ThreadRunner : public Thread {
    unsigned int intervalMillis;

public :
    ThreadRunner( unsigned int intervalMillis ) {
        this->intervalMillis = intervalMillis;
        ThreadControl tc = start();
        tc.detach();
    }

    void run() {
        Time interval = Time::milliSeconds( intervalMillis );
        while ( true ) {
            Thread *t = new DummyThread();
            ThreadControl::sleep( interval );
        }
    }
};

int main( int argc, char **argv ) {
    cout << "Testing IceUtil::Thread" << endl;

    int i;
    for ( i = 0; i < 50; ++i ) {
        // Each ThreadRunner will create DummyThreads once every second.
        Thread *t = new ThreadRunner( 1000 );
    }

    while ( true ) {
        ThreadControl::sleep( Time::seconds(1) );
    }

    return 0;
}
